import java.util.*;
import java.io.*;
import java.text.*;

/*
 * Cet algorithme permet de faire un tirage au sort distribué entre n PCs
 * lister l'adresse IP local des PCs dans le fichier "liste_adresses_IP.txt" du dossier
 * 
 * */
public class main {

// Parametres controlables
	public static int numero_port = 5544;				//Il faut utiliser le même sur toutes les machines !
	private static int duree_cycle = 500;
	private static int taille_max_liste_finale=10;
//Parametres
	public static Thread S,C,Cl;
	public static int nb;
	public static int taille_liste_adresses_IP;
	
	//jdfklhsdkljflsqdmklfmklsqd
	public static int modulo;
	public static boolean verification = true;
	public static boolean checkModulo = true;
	
	public static void main(String[] args) {
		
//Création des fichiers nécessaires à l'algo
		new File("liste_temporaire_reception.txt").delete();
		new File("liste_temporaire_reception.txt");
		new File("liste_finale.txt").delete();
		new File("liste_finale.txt");
		new File("liste_temporaire_modulo.txt").delete();
		new File("liste_temporaire_modulo.txt");
		taille_liste_adresses_IP();			//initialise la valeur de la taille de la liste
//Lancement du serveur
		S = new Thread (new Serveur());
		S.start();	

// La Timer Task permet de lancer les Threads Clients après que tous les serveurs soient lancés

		Timer timer = new Timer();
		TimerTask task = new TimerTask(){
			public void run(){
				
//DEBUT BOUCLE TEMPORELLE, mettre "true" ou "taille_max_liste_finale"
				while(true){
					long d = System.currentTimeMillis()+duree_cycle;
					taille_liste_adresses_IP=0;
					nb = generation_nb_aleatoire(50);
					envoyer_IP("liste_adresses_IP.txt");	
					temporiser_ms(100);
					modulo = calcul_modulo();
					
					//sgblhyukdfmtyoimhdlrimyoif
//Vérification que tous les PCs ont bien calculé le même nombre
					checkModulo = true;
//Ajout du nombre à la liste finale si la valeur est partagée par tous
					if(verificationModulo("liste_adresses_IP.txt")){
						ecriture_fichier(modulo,"liste_finale.txt");
					}					
//Temporisation pour que tous les PCs aient fini de mettre à jour leur liste_finale avant de passer au cycle suivant
					while(System.currentTimeMillis()<d){
					}	
				}
				
			}
		};
//On rentre ici la date à laquelle on veut que tous les PCs lancent leurs clients
		Date dateStart = date(2017,05,18,20,29,30);
		timer.schedule(task, dateStart);
		
	}


//METHODES
	
	private static boolean verificationModulo(String fichier){
		//boolean verification = true;
		checkModulo = true;
		
		try{
            Scanner sce = new Scanner(new File(fichier));
            while(sce.hasNext()){
            	Cl = new Thread(new Client(sce.nextLine(),modulo));
    			Cl.start();
    			temporiser_ms(50);
            }
            sce.close();
        }catch (FileNotFoundException e) { 
            System.err.println("Le fichier n'existe pas !");
        }
		
		return verification;
	}

//date(annees,mois,jours,heures,minutes,secondes): rend un objet date à celle voulue
	private static Date date(int anne, int mois, int jour, int heure, int minute, int seconde){
		SimpleDateFormat dateFormat = new SimpleDateFormat ("yyyy-MM-dd HH:mm:ss");
		String dateStartString = anne+"-"+mois+"-"+jour+" "+heure+":"+minute+":"+seconde;
		Date dateStart = new Date();
		try{
			// Convert start date to a Date format (it should be inside a try)
			dateStart = dateFormat.parse(dateStartString); 
		}catch(ParseException e){
		}
		return dateStart;
	}
	
//ecriture_fichier: écrit un int dans le fichier
	private static void ecriture_fichier(int nombre,String fichier){
		try {			
			PrintWriter pWriter = new PrintWriter(new FileWriter(fichier, true));
			pWriter.print(nombre+"\n");
			pWriter.close();			
			} catch (IOException e) {e.printStackTrace();}
		}	
	
//calcul_modulo() : Calcule la somme des nombres recus modulo le nombre de client(lui compris)
	private static int calcul_modulo(){
		int modulo=0;
		try{
            Scanner sc = new Scanner(new File("liste_temporaire_reception.txt"));
            while(sc.hasNext()){
            	modulo=modulo+Integer.parseInt(sc.nextLine());
            }
            sc.close();
            new File("liste_temporaire_reception.txt").delete();
            try {			
    			PrintWriter pWriter = new PrintWriter(new FileWriter("liste_temporaire_reception.txt",true));
    			pWriter.close();			
    			} catch (IOException e) {e.printStackTrace();}
        }catch (FileNotFoundException e) { 
            System.err.println("Le fichier n'existe pas !");
        }
		System.out.println("\n"+"Somme: "+modulo+"\n"+"modulo: "+taille_liste_adresses_IP);
		modulo = modulo % taille_liste_adresses_IP;
		System.out.println("Résultat: "+ modulo+"\n");
		return modulo;
		}
	private static void taille_liste_adresses_IP(){
		try{
            Scanner sc = new Scanner(new File("liste_adresses_IP.txt"));
            while(sc.hasNext()){
            	sc.nextLine();
            	taille_liste_adresses_IP++;
            }
            sc.close();
        }catch (FileNotFoundException e) { 
            System.err.println("Le fichier n'existe pas !");
        	}
		}

//envoyer_ip(fichier): Envoie le tirage aléatoire aux Pcs dont l'IP dans le fichier
	private static void envoyer_IP(String fichier){
		
		//kljsfrhgkljdmkslfjg		
		checkModulo = false;
		try{
            Scanner sc = new Scanner(new File(fichier));
            while(sc.hasNext()){
            	C= new Thread (new Client(sc.nextLine(),nb));
    			C.start();
    			temporiser_ms(50);		//A optimiser, laisse le temps
            }
            sc.close();
        }catch (FileNotFoundException e) { 
            System.err.println("Le fichier n'existe pas !");
        }
	}
//generation_nb_aleatoire(range) : genere un nombre aleatoire entre 1 et range
	public static int generation_nb_aleatoire(int range){
		int nb =-1;
		Random rand = new Random();
		nb= rand.nextInt(range)+1;		
		return nb;
	}
//temporiser_ms(temps): mets le Thread courant en pause pour la durée en ms
	//mkslfbgjkhdfgkljsdklfj
	public static void temporiser_ms(int temps){
		try{
			Thread.sleep(temps);
		} catch(InterruptedException e){
			System.out.println("Attente interrompue !");
		}
	}	
}